This page describes efforts to port PyLint to Python 3.x

This page is years old. PyLint 1.0.0 has been released with support for Python 3.

Status of the port

Goals and high level overview of tasks

The idea is to add support for Python 3.0 and 3.1, while eliminating Python 2.4 compatibility because that will simplify some of the code.


These are all things related to doing Python 2 to 3 ports:

The main issues appear to be:

      iter = d.iteritems()
    except AttributeError:
      iter = d.items()

    except exceptions.AttributeError:
      # not in
      # in


Working with the SCM

Running the tests

Notes on logilab-common

handling with different Python versions. This is also to be used for astng / pylint. Until now, it could be avoided to use sa2to3.

Most of the work for making logilab-common Py3k compatible is done. With the current work, and after running 2to3, one can use Pytest or
  •   python test/

nevertheless can be used for running the astng/pylint tests.

Notes on Astng

and some 'visit_<node_name>' methods for the visitors in Astng.

PyLint-3k (last edited 2013-12-02 00:10:57 by Charles Merriam)

Unable to edit the page? See the FrontPage for instructions.